//============================================================================
// Name        : BLS_TSP.cpp
// Author      :
// Version     : This code is used to implement BLS solving CTSP, colored traveling salesman problem
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================
// read_me: the data structure of this code for solution is an array whose value is the index of the next city
#include "local_search.h"
#include "read.h"
#include <iostream>
#include <cstdlib>
#include <unistd.h>
using namespace std;
int ex;
int num_v;
int v_num;
int *x_y;// this variable is used to save the coordination of all nodes and characteristics which means which nodes could be visited by vehicles.
double ** Distance;
int record;
int iterations=1000;
solution p;
solution best_p;
solution g_best_p;
solution tem_pi;
int *Hx1;
int * Hx2;
int ** tabu;
double ** delta_insert;
double ** delta_zero;
int time_length;
int seed;
// all parameters which need to be adjusted should be added in basic.h.
void release_memory()
{
	for (int i=0;i<=num_v;i++)
		delete [] Distance[i];
	delete [] Distance;
	delete [] x_y;
	for (int i=0;i<=v_num-1;i++)
	{
		delete [] p.sol[i];
		delete [] p.sol_r[i];
		delete [] tem_pi.sol[i];
		delete [] tem_pi.sol_r[i];
		delete [] best_p.sol[i];
		delete [] g_best_p.sol[i];
	}
	delete [] p.sol;
	delete [] p.sol_r;
	delete [] tem_pi.sol;
	delete [] tem_pi.sol_r;
	delete [] best_p.sol;
	delete [] g_best_p.sol;
	for (int i=0;i<=num_v;i++)
	{
		delete [] tabu[i]; // this tabu table is used for optimizing tsp.
	}
	delete [] tabu;
	delete [] Hx1;
	delete [] Hx2;
	for (int i=0;i<=num_v;i++)
	{
		delete [] delta_insert[i];
	}
	delete [] delta_insert;
	for (int i=0;i<=v_num-1;i++)
		delete [] delta_zero[i];
	delete [] delta_zero;
}
void initial_dynamic_array()
{
	tem_pi.sol=new int *[v_num];
	tem_pi.sol_r=new int *[v_num];
	for (int i=0;i<=v_num-1;i++)
	{
		tem_pi.sol[i]=new int [num_v+1];
		tem_pi.sol_r[i]=new int [num_v+1];
	}
	Hx1=new int [Max_length];
	Hx2=new int [Max_length];
	tabu=new int * [num_v+1];
	for (int i=0;i<=num_v;i++)
	{
		tabu[i]=new int [num_v+1];
	}
	delta_insert=new double * [num_v+1];
	for (int i=0;i<=num_v;i++)
	{
		delta_insert[i]=new double [num_v+1];
	}
	delta_zero=new double * [v_num];
	for (int i=0;i<=v_num-1;i++)
		delta_zero[i]=new double [num_v+1];
}
int main(int argc, char*argv[])
{
	if (argc!=5)
	{
		cout << "the input parameters in configuration are wrong" << endl;
		return 1;
	}
	sscanf(argv[2],"%d",&num_v);
	sscanf(argv[3],"%d",&time_length);
	sscanf(argv[4],"%d",&seed);
	if(build_instance(argv[1])!=1)
	{
		cout<<"can't open instance file"<<endl;
		return -1;
	}
	srand(seed);// generate a random number;
	clock_t start = clock();
	clock_t optimal_time;
	initial_population(p, best_p,g_best_p);
	initial_dynamic_array();
	for (int i=1;i<=num_v;i++)
		if (x_y[i]==0)
		{
			record=i;break;
		}
	g_best_p.fit=Max;
	single_solution(p,best_p);
	best_p.fit=Max;
	main_search(p,best_p,g_best_p,Hx1,Hx2,start,time_length,optimal_time,delta_insert,delta_zero,tabu,tem_pi);
	output_function(g_best_p,seed,optimal_time);
	release_memory();
	// this place is used to output the results.
	return 0;
}
