//============================================================================
// Name        : BLS_TSP.cpp
// Author      : pengfei he
// Version     : This code is used to implement BLS solving CTSP, colored traveling salesman problem
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================
// read_me: the data structure of this code for solution is an array whose value is the index of the next city
#include <iostream>
#include <vector>
#include <fstream>
#include <cstdlib>
#include <unistd.h>
#include <string.h>
#include <sys/times.h>
#include <cmath>
#include <string>
#include <iterator>
#include <valarray>
#include <stdlib.h>
#include <algorithm>
using namespace std;
#define neb 100 // the number of employ bee
#define nob 150 // the number of onlooker bee
#define Max 100000000
#define Pbts 70
#define Pmin 0.1
#define Pmax 0.7
#define limit_scout 125
#define iter_max    125
struct  solution  // all dynamic array should be defined as gloal variables
{
	int **sol;
	int ** sol_r;
	double * list_cost;// this array is used to save the cost for each tour.
	double fit;
	int no_impro;
};
int ex;
int num_v;
int v_num;
int time_length;
int seed;
int *x_y;// this variable is used to save the coordination of all nodes and characteristics which means which nodes could be visited by vehicles.
double ** Distance;
int step=1;
solution best_food;// to keep the best food
// all parameters which need to be adjusted should be added in basic.h.
solution food [neb];//in this code, the number of employ bee is the number of food
solution new_food;
clock_t start;
vector<double >record;
void release_memory()
{
	for (int i=0;i<=num_v;i++)
	{
		delete [] Distance[i];
	}
	for (int i=0;i<=v_num-1;i++)
	{
		delete [] best_food.sol[i];
		delete [] best_food.sol_r[i];
		delete [] new_food.sol[i];
		delete [] new_food.sol_r[i];
	}
	delete [] Distance;
	delete [] x_y;
	delete [] best_food.sol;
	delete [] best_food.sol_r;
	delete [] new_food.sol;
	delete [] new_food.sol_r;
	delete [] new_food.list_cost;
	for (int i=0;i<=neb-1;i++)
	{
		for (int j=0;j<=v_num-1;j++)
		{
			delete [] food[i].sol[j];
			delete [] food[i].sol_r[j];
		}
		delete [] food[i].sol;
		delete [] food[i].sol_r;
		delete [] food[i].list_cost;
	}
}
int build_instance(char *file_name)
{
	ifstream open_file(file_name);
	x_y=new int [num_v+1];// the first and second colmun is used to save the coordinate and the third is used to save the characteristics
	for (int i=0;i<=num_v;i++)
		x_y[i]=0;
	char aa[10];
	open_file>>aa;
	int num;
	while (1)
	{
		open_file>>num;
		if (num==num_v)
		{
			open_file>>v_num;open_file>>ex;
			break;
		}
	}
	int count=1;int iden=1;
	for (int i=1;i<=num_v;)
	{
		if (count<=ex)
		{
			x_y[i]=iden;count++;i++;
		}
		else
		{
			count=1;iden++;
		}
		if (i>ex*v_num)
			break;
	}
//	Distance =new int * [num_v+1];
//	for (int i=0;i<=num_v;i++)
//		Distance[i]=new int [num_v+1];
//	for (int i=0;i<=num_v;i++)
//		for (int j=0;j<=num_v;j++)
//			open_file>>Distance[i][j];
//	open_file.close();
	int c;double x[num_v+1];double y[num_v+1];    //
	for (int i=0;i<=num_v;i++)                                            //
	{
		open_file>>c;open_file>>x[i];open_file>>y[i];//
	}
	open_file.close();                                                               //
	Distance =new double * [num_v+1];
	for (int i=0;i<=num_v;i++)
		Distance[i]=new double [num_v+1];
	if (num_v<=200 || (num_v>900 && num_v<5000)){
		for (int i=0;i<=num_v;i++)
			for (int j=0;j<=num_v;j++)
					Distance[i][j]=sqrt((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]));
	}
	if (num_v>5000){
		for (int i=0;i<=num_v;i++)
			for (int j=0;j<=num_v;j++)
				Distance[i][j]=ceil(sqrt((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j])));
	}
	if (num_v>200 && num_v<700){
		double q1,q2,q3;
		double RRR = 6378.388;
		double latitude[num_v+1];
		double longitude[num_v+1];
		double min;
		double deg;
		double PI=3.141592;
		for (int i=0;i<=num_v;i++){
			deg=int(x[i]);
			min=x[i]-deg;
			latitude[i]=PI * (deg + 5.0 * min / 3.0 ) / 180.0;
			deg=int(y[i]);
			min=y[i]-deg;
			longitude[i]=PI * (deg + 5.0 * min / 3.0 ) / 180.0;
		}
		for (int i=0;i<=num_v;i++)
			for (int j=0;j<=num_v;j++){
				q1 = cos( longitude[i] - longitude[j] );
				q2 = cos( latitude[i] - latitude[j] );
				q3 = cos( latitude[i] + latitude[j] );
				Distance[i][j] = (int) ( RRR * acos( 0.5*((1.0+q1)*q2 - (1.0-q1)*q3) ) + 1.0);
			}
	}
	return 1;
}
void construct(int n)// this function is used to construct an initial solution for food[n]
{
	for (int j=0;j<=v_num-1;j++)
	{
		for (int k=0;k<=num_v;k++)
		{
			food[n].sol[j][k]=-1;
			food[n].sol_r[j][k]=-1;
		}
	}
	food[n].fit=Max;
	vector<int >node;// this vector is used to keep all
	for (int i=0;i<=num_v;i++)
		node.push_back(i);// the first node is 0 and the last node is num_v;
	random_shuffle(node.begin()+1, node.end());// except node 0, the remain nodes are random.
	int p;
	int t;
	double delta;
	double tem;
	int loc;int row;// these two variables are used to define the localtion where the new node should be inserted
	int n_1;
	for (int i=1;i<=num_v;i++)// loop num_v times for insert all nodes.
	{	// the sequence of node is random.
		if (x_y[node[i]]>0)// if this node is exclusive. the best place only need to consider a tour
		{
			t=x_y[node[i]]-1;// the tour/row.
			p=0;
			if (food[n].sol[t][p]==-1)// this tour not has any nodes.
				food[n].sol[t][p]=node[i];
			else // this tour has nodes with not knowing many nodes.
			{
				delta=Max;
				while(1)
				{
					if (food[n].sol[t][p]==-1)
						tem=Distance[node[i]][p]+Distance[node[i]][0]-Distance[p][0];
					else
						tem=Distance[node[i]][p]+Distance[node[i]][food[n].sol[t][p]]-Distance[p][food[n].sol[t][p]];
					if (tem<delta)
					{
						delta=tem;
						loc=p;
					}
					p=food[n].sol[t][p];
					if (p==-1)
						break;
				}
				n_1=food[n].sol[t][loc];
				food[n].sol[t][loc]=node[i];
				food[n].sol[t][node[i]]=n_1;
			}
		}
		else // this node is not excelusive, the best place should consider all tours.
		{
			delta=Max;
			for (int j=0;j<=v_num-1;j++)// loop for all nodes
			{
				p=0;
				if (food[n].sol[j][p]==-1)// there is no node in tour j.
				{
					tem=Distance[p][node[i]]+Distance[node[i]][p];
					if (delta>tem)
					{
						delta=tem;
						loc=p;
						row=j;
					}
				}
				else// there are many nodes in tour j.
				{
					while (1)
					{
						if (food[n].sol[j][p]==-1)
							tem=Distance[p][node[i]]+Distance[node[i]][0];
						else
							tem=Distance[p][node[i]]+Distance[node[i]][food[n].sol[j][p]]-Distance[p][food[n].sol[j][p]];
						if (tem<delta)
						{
							delta=tem;
							loc=p;
							row=j;
						}
						p=food[n].sol[j][p];
						if (p==-1)
							break;
					}
				}
			}
			n_1=food[n].sol[row][loc];
			food[n].sol[row][loc]=node[i];
			food[n].sol[row][node[i]]=n_1;
		}
	}
	for (int i=0;i<=v_num-1;i++)
	{
		p=0;
		while (1)
		{
			if(food[n].sol[i][p]==-1)
			{
				food[n].sol[i][p]=0;
				break;
			}
			else
				p=food[n].sol[i][p];
		}
	}
	delta=0;// this variable is used to calculate the objective
	double delta_list;
	for (int i=0;i<=v_num-1;i++)
	{
		delta_list=0;
		p=0;
		while (1)
		{
			delta_list+=Distance[p][food[n].sol[i][p]];
			if (food[n].sol[i][p]==0)
				break;
			p=food[n].sol[i][p];
		}
		delta+=delta_list;
		food[n].list_cost[i]=delta_list;
	}
	food[n].fit=delta;
	food[n].no_impro=0;
	// reverse
	vector<int >tour;
	for (int i=0;i<=v_num-1;i++)
	{
		p=food[n].sol[i][0];
		while (p!=0)
		{
			tour.push_back(p);
			p=food[n].sol[i][p];
		}
		food[n].sol_r[i][0]=tour.back();
		tour.pop_back();
		p=food[n].sol_r[i][0];
		while (tour.size())
		{
			food[n].sol_r[i][p]=tour.back();
			p=food[n].sol_r[i][p];
			tour.pop_back();
		}
		food[n].sol_r[i][p]=0;
	}
}
void initial_population()
{
	// initial variables
	for (int i=0;i<=neb-1;i++)
	{
		food[i].sol=new int * [v_num];
		food[i].sol_r=new int * [v_num];
		food[i].list_cost=new double  [v_num];
		for (int j=0;j<=v_num-1;j++)
		{
			food[i].sol[j]=new int [num_v+1];
			food[i].sol_r[j]=new int [num_v+1];
		}
	}
	for (int i=0;i<=neb-1;i++)
	{
		for (int j=0;j<=v_num-1;j++)
		{
			for (int k=0;k<=num_v;k++)
			{
				food[i].sol[j][k]=-1;
				food[i].sol_r[j][k]=-1;
			}
		}
	}
	best_food.sol=new int *[v_num];
	best_food.sol_r=new int *[v_num];
	new_food.sol=new int *[v_num];
	new_food.sol_r=new int *[v_num];
	new_food.list_cost=new double [v_num];
	for (int i=0;i<=v_num-1;i++)
	{
		best_food.sol[i]=new int [num_v+1];
		best_food.sol_r[i]=new int [num_v+1];
		new_food.sol[i]=new int [num_v+1];
		new_food.sol_r[i]=new int [num_v+1];
	}
	for (int i=0;i<=v_num-1;i++)
	{
		for (int j=0;j<=num_v;j++)
		{
			best_food.sol[i][j]=-1;
			best_food.sol_r[i][j]=-1;
			new_food.sol[i][j]=-1;
			new_food.sol_r[i][j]=-1;
		}
	}
	for (int i=0;i<=v_num-1;i++)
		for (int j=0;j<=num_v;j++)
		{
			best_food.sol[i][j]=-1;
		}
	best_food.fit=Max;
	// constructing initial solutions for all individuals
	for (int i=0;i<=neb-1;i++)
	{
		construct(i);
	}
}
double determin_Pcp(int n)
{
	double Pcp;
	if (step<=iter_max)
	{
		Pcp=((Pmax-Pmin)/iter_max)+Pmin;
	}
	else
		Pcp=Pmax;
	return Pcp;
}
void determine_best(double best_fit)// the function of this fun is to update the best solution from population.
{
	int index=-1;
	for (int i=0;i<=neb-1;i++)
	{
		if (food[i].fit<best_fit)
		{
			best_fit=food[i].fit;
			index=i;
		}
	}
	if (index!=-1)
	{
		best_food.fit=food[index].fit;
		for (int i=0;i<=v_num-1;i++)
			for (int j=0;j<=num_v;j++)
				best_food.sol[i][j]=food[index].sol[i][j];
	}
}
void extract_nodes(vector<int> &unassign,int n)
{
	for (int i=0;i<=v_num-1;i++)
		for (int j=0; j<=num_v;j++)
		{
			new_food.sol[i][j]=food[n].sol[i][j];
			new_food.sol_r[i][j]=food[n].sol_r[i][j];
		}
	// delete nodes from new_food.       attention a case which all nodes are deleted.
	int p;int p_n;int p_p;int pp;
	double Pcp=determin_Pcp(n);
	for (int i=0;i<=v_num-1;i++)
	{
		p=new_food.sol[i][0];
		while(1)
		{
			if (p!=0)
			{
				if ((rand()%10000)>=(ceil(10000*Pcp)))//this is an important probability determine by a function
				{
					pp=new_food.sol[i][p];
					unassign.push_back(p);
					p_n=new_food.sol[i][p];
					p_p=new_food.sol_r[i][p];
					new_food.sol[i][p_p]=p_n;
					new_food.sol[i][p]=-1;
					new_food.sol_r[i][p_n]=p_p;
					new_food.sol_r[i][p]=-1;
					p=pp;
				}
				else
					p=new_food.sol[i][p];
			}
			else
				break;
		}
	}
}

void insert_intra(int n)
{
	for (int i=0;i<=v_num-1;i++)
		for (int j=0; j<=num_v;j++)
		{
			new_food.sol[i][j]=food[n].sol[i][j];
			new_food.sol_r[i][j]=food[n].sol_r[i][j];
		}
	// delete nodes from new_food.       attention a case which all nodes are deleted.
	vector<int >unassign;
	int p;int p_n;int p_p;int pp;
	double Pcp=determin_Pcp(n);// to determine the probability which node is selected
	for (int i=0;i<=v_num-1;i++)
	{
		p=new_food.sol[i][0];
		while(1)
		{
			if (p!=0)
			{
				if ((rand()%1000)>=ceil(Pcp*1000))//this is an important probability determine by a function
				{
					pp=new_food.sol[i][p];
					unassign.push_back(p);
					p_n=new_food.sol[i][p];
					p_p=new_food.sol_r[i][p];
					new_food.sol[i][p_p]=p_n;
					new_food.sol[i][p]=-1;
					new_food.sol_r[i][p_n]=p_p;
					new_food.sol_r[i][p]=-1;
					p=pp;
				}
				else
					p=new_food.sol[i][p];
			}
			else
				break;
		}
		random_shuffle(unassign.begin(),unassign.end());
		int length=unassign.size();
		int loc; // ro record which location the node inserting
		int n_t;// a repalce variable.
		double delta;
		double tem;
		for (int j=0;j<=length-1;j++)
		{
			delta=Max;
			p=0;
			while (1)
			{
				if (new_food.sol[i][0]==0)
				{
					loc=0;
					break;
				}
				else
				{
					tem=Distance[p][unassign[j]]+Distance[unassign[j]][new_food.sol[i][p]]-Distance[p][new_food.sol[i][p]];
					if (tem<delta)
					{
						delta=tem;
						loc=p;
					}
				}
				p=new_food.sol[i][p];
				if (p==0)
					break;
			}
			n_t=new_food.sol[i][loc];
			new_food.sol[i][loc]=unassign[j];
			new_food.sol[i][unassign[j]]=n_t;
		}
		unassign.erase(unassign.begin(),unassign.end());
	}
}
void insert_fun(vector<int> & unassign)// inserting all nodes in unassign to food.
{
	int length=unassign.size();
	int t;// to remember which tour is selected
	int p;// pointer to record which node.
	int row;// to record which tour the unassigning node insert
	int loc; // ro record which location the node inserting
	int n_t;// a repalce variable.
	double delta;
	double tem;
	for (int i=0;i<=length-1;i++)// insert all nodes in unassign to new_food
	{
		delta=Max;
		if (x_y[unassign[i]]>0)
		{
			t=x_y[unassign[i]]-1;
			p=0;
			while (1)
			{
				if (new_food.sol[t][0]==0)
				{
					tem=Distance[p][unassign[i]]+Distance[new_food.sol[t][p]][unassign[i]];
					if (delta>tem)
					{
						delta=tem;
						row=t;
						loc=p;
					}
					break;
				}
				else
				{
					tem=Distance[p][unassign[i]]+Distance[unassign[i]][new_food.sol[t][p]]-Distance[p][new_food.sol[t][p]];
					if (tem<delta)
					{
						delta=tem;
						row=t;
						loc=p;
					}
				}
				p=new_food.sol[t][p];
				if (p==0)
					break;
			}
		}
		else
		{
			for (int j=0;j<=v_num-1;j++)
			{
				p=0;
				while (1)
				{
					if (new_food.sol[j][0]==0)
					{
						tem=Distance[p][unassign[i]]+Distance[unassign[i]][new_food.sol[j][p]];
						if (tem<delta)
						{
							delta=tem;
							row=j;
							loc=p;
						}
						break;
					}
					else
					{
						tem=Distance[p][unassign[i]]+Distance[unassign[i]][new_food.sol[j][p]]-Distance[p][new_food.sol[j][p]];
						if (tem<delta)
						{
							delta=tem;
							row=j;
							loc=p;
						}
					}
					p=new_food.sol[j][p];
					if (p==0)
						break;
				}
			}
		}
		n_t=new_food.sol[row][loc];
		new_food.sol[row][loc]=unassign[i];
		new_food.sol[row][unassign[i]]=n_t;
		new_food.sol_r[row][n_t]=unassign[i];
		new_food.sol_r[row][unassign[i]]=loc;
	}
	new_food.fit=0;
	for (int i=0;i<=v_num-1;i++)
	{
		p=0;delta=0;
		while (1)
		{
			delta+=Distance[p][new_food.sol[i][p]];
			p=new_food.sol[i][p];
			if (p==0)
				break;
		}
		new_food.list_cost[i]=delta;
	}
	for (int i=0;i<=v_num-1;i++)
		new_food.fit+=new_food.list_cost[i];
}
void neighbor_intra(int n)
{
	insert_intra(n);
	// to calculate the total distance for each tour for new_food and food[n];
	double delta;int p;
	for (int i=0;i<=v_num-1;i++)
	{
		delta=0;
		p=0;
		while (1)
		{
			delta+=Distance[p][new_food.sol[i][p]];
			if (new_food.sol[i][p]==0)
				break;
			p=new_food.sol[i][p];
		}
		if (delta<food[n].list_cost[i])
		{
			food[n].list_cost[i]=delta;
			food[n].no_impro=0;
			for (int j=0;j<=num_v;j++)
				food[n].sol[i][j]=new_food.sol[i][j];
		}
	}
	food[n].fit=0;
	for (int i=0;i<=v_num-1;i++)
	{
		food[n].fit+=food[n].list_cost[i];
	}
	vector<int >tour;
	for (int i=0;i<=v_num-1;i++)
	{
		p=food[n].sol[i][0];
		while (p!=0)
		{
			tour.push_back(p);
			p=food[n].sol[i][p];
		}
		food[n].sol_r[i][0]=tour.back();
		tour.pop_back();
		p=food[n].sol_r[i][0];
		while (tour.size())
		{
			food[n].sol_r[i][p]=tour.back();
			p=food[n].sol_r[i][p];
			tour.pop_back();
		}
		food[n].sol_r[i][p]=0;
	}
}
void neighbor_inter(int n)//this function is used to construct a new solution for food[n] and update it
{// the main parameters are food[n] and new_food.
	// the first step is to initial new_food
	vector<int>unassign;// this vector is used to keep all nodes deleted from new_food
	extract_nodes(unassign,n);
	random_shuffle(unassign.begin(), unassign.end());// random all nodes in unassign
	// insert all nodes.
	insert_fun(unassign);
	if (food[n].fit>new_food.fit)
	{
		food[n].no_impro=0;
		food[n].fit=new_food.fit;
		for (int i=0;i<=v_num-1;i++)
			for (int j=0; j<=num_v;j++)
			{
				food[n].sol[i][j]=new_food.sol[i][j];
				food[n].sol_r[i][j]=new_food.sol_r[i][j];
			}
	}
	double delta;int p;
	for (int i=0;i<=v_num-1;i++)
	{
		delta=0;p=0;
		while (1)
		{
			delta+=Distance[p][food[n].sol[i][p]];
			if (food[n].sol[i][p]==0)
				break;
			p=food[n].sol[i][p];
		}
		food[n].list_cost[i]=delta;
	}
}
int bts (int c1, int c2)
{
	int re;
	if (food[c1].fit > food[c2].fit)
	{
		if (rand()%100>Pbts)
			re=c2;
		else
			re=c1;
	}
	if (food[c1].fit <= food[c2].fit)
	{
		if ((rand() % 100)>Pbts)
				re=c1;
		else
			re=c2;
	}
	return re;
}
void ABC()
{
	int last_time=0;
	int p;step=1;
	determine_best(best_food.fit);// update best solution from initial population
	while(1)
	{

		int now_time=clock()/CLOCKS_PER_SEC;
		if (now_time-last_time>0){
			record.push_back(best_food.fit);
			last_time=now_time;

		}
		for (int i=0;i<=neb-1;i++)
		{
			neighbor_intra(i);
			neighbor_inter(i);// to generate a nerighborhood solution for food[i];
		}
		for (int i=0;i<=nob-1;i++)
		{
			int c_1,c_2;
			while(1)
			{
				c_1=rand()%neb;c_2=rand()%neb;
				if (c_1!=c_2)
					break;
			}
			p=bts(c_1,c_2);// this function is used to find the probability which is used to select which food is onlook bee.
			neighbor_intra(p);
			neighbor_inter(p);// to generate a nerighborhood solution for food[i];
		}
		determine_best(best_food.fit);
		cout<<step<<"   "<<best_food.fit<<endl;
		for (int i=0;i<=neb-1;i++)
		{
			if (food[i].no_impro>limit_scout)
				construct(i);
		}
		step++;
		if(ceil((clock() - start)/static_cast<double>(CLOCKS_PER_SEC))>=time_length)
			break;
	}
}
void output_function()
{
	int pointer;
	char name_instance[100]={0};
	sprintf(name_instance, "%d", num_v+1);
	int size=strlen (name_instance);
	name_instance[size]='_';
	size=strlen( name_instance);
	char num_vehcile[10];
	sprintf(num_vehcile, "%d", v_num);
	int size_1=strlen(num_vehcile);
	for (int i=0;i<=size_1-1;i++)
	{
		name_instance[size]=num_vehcile[i];size++;
	}
	name_instance[size]='_';size++;
	char seed_name[10];
	sprintf(seed_name, "%d", seed);
	size_1=strlen( seed_name);
	for (int i=0;i<=size_1-1;i++)
	{
		name_instance[size]=seed_name[i];size++;
	}
	char tx[4]={'.','t','x','t'};
	for (int i=0;i<=3;i++)
	{
		name_instance[size]=tx[i];size++;
	}
	ofstream out (name_instance);
	out<<"the best solution's fitness is "<<endl<<best_food.fit<<endl;
	//out<< "the time get the best solution is "<<endl<<optimal_time<<endl;
	out<<"the sequence of best solution is following"<<endl;
	for (int i=0;i<=v_num-1;i++)
	{
		pointer=0;
		while (1)
		{
			out<<pointer<<" ";
			pointer=best_food.sol[i][pointer];
			if (pointer==0)
				break;
		}
		out<<endl;
	}
	out<<endl;
	double cost=0;int p;
	for (int i=0;i<=v_num-1;i++)
	{
		p=0;
		while (1)
		{
			cost+=Distance[p][best_food.sol[i][p]];
			if (best_food.sol[i][p]==0)
				break;
			p=best_food.sol[i][p];
		}
	}
	out<<"the actuall costs is "<<cost<<endl;

	int size_length=record.size();
	for (int i=0;i<=size_length-1;i++){
		out<<i<<"  "<<record[i]<<endl;
	}
	out<<endl;
}
int main(int argc, char*argv[])
{

	if (argc!=5)
	{
		cout << "the input parameters in configuration are wrong" << endl;
		return 1;
	}
	sscanf(argv[2],"%d",&num_v);
	sscanf(argv[3],"%d",&time_length);
	sscanf(argv[4],"%d",&seed);
	if(build_instance(argv[1])!=1)
	{
		cout<<"can't open instance file"<<endl;
		return -1;
	}
	srand(seed);// generate a random number;
	start=clock();
	initial_population();
	ABC();
	output_function();
	release_memory();
	return 0;
}
